/* eslint-disable no-unused-vars */
import { Palette } from "@mui/material/styles";
export namespace FoundationTheme {

    export type Mode = 'light' | 'dark';

    export type HexColor = `#${string}`;

    export type CommonColors = {
        white: string;
        black: string;
    }

    type ColorGroupPrimary = {
        primary? : {
            black: HexColor;
            white: HexColor;
            gray: HexColor;
            dark: HexColor;
        }
    } 
    
    export type PaletteColors = "primary"
        | "neutral"
        | "accentColorA"
        | "accentColorB" 
        | "accentColorC" 
        | "accentColorD"
        | "secondary"
        | "success"
        | "warning"
        | "error"
        | "info";

    export type AppColors = PaletteColors | "custom";
    
    export type Colors = {
        [paletteColor in AppColors]?: {
            [colorId: string]: string | { main: string, dark?: string };
        } & ColorGroupPrimary;
    };

    export interface ButtonState {
        hovered?: string;
        hoveredText?: string;
        pressed?: string;
        pressedText?: string;
        focused?: string;
        focusedText?: string;
        disabled?: string;
        disabledText?: string;
    }

    export type PaletteColorType = {
        main: string;
        contrastText: string;
        buttonState?: ButtonState;
        darkMode?: {
            main: string;
            contrastText: string;
            buttonState?: ButtonState;
        }
    };

    export type Theme = {
        palette?: Palette;
        colors?: Colors;
    };

}