import { Palette } from "@mui/material/styles";

import colors from "./colors";

const palette: Palette = {
    primary: {
        main: colors.primary.black,
        contrastText: colors.primary.white,
        buttonState: {
            hovered: colors.neutral[60],
            disabled: colors.neutral[40],
            pressed: colors.primary.gray,
            focused: colors.primary.black,
            disabledText: colors.neutral[60],
        },
        darkMode: {
            main: colors.primary.gray,
            contrastText: colors.primary.black,
            buttonState: {
                hovered: colors.accentColorA[600],
                hoveredText: colors.primary.white,
                pressed: colors.accentColorA[500],
                pressedText: colors.primary.white,
                focused: colors.primary.gray,
                disabled: colors.neutral[70],
            }
        }
    },
    secondary: {
        main: colors.primary.white,
        contrastText: colors.primary.black,
        buttonState: {
            hovered: colors.neutral[30],
            pressed: colors.neutral[40],
            focused: colors.primary.white,
            disabled: colors.neutral[40],
            disabledText: colors.neutral[60],
        },
    },
    accentColorA: {
        main: colors.accentColorA[30].main,
        contrastText: colors.primary.white,
        buttonState: {
            hovered: colors.accentColorA[40],
            pressed: colors.accentColorA[50],
            focused: colors.accentColorA[30].main,
            disabled: colors.neutral[40],
            disabledText: colors.neutral[60],
        },
        darkMode: {
            main: colors.accentColorA?.[30].dark,
            contrastText: colors.primary.black,
        }
    },
    accentColorB: {
        main: colors.accentColorB[30],
        contrastText: colors.primary.white,
        buttonState: {
            hovered: colors.accentColorB[40],
            pressed: colors.accentColorB[50],
            focused: colors.accentColorB[30],
            disabled: colors.neutral[40],
            disabledText: colors.neutral[60],
        },
    },
    accentColorC: {
        main: colors.accentColorC[30].main,
        contrastText: colors.primary.white,
        buttonState: {
            hovered: colors.accentColorC[40],
            pressed: colors.accentColorA[50],
            focused: colors.accentColorA[30].main,
            disabled: colors.neutral[40],
            disabledText: colors.neutral[60],
        },
        darkMode: {
            main: colors.accentColorC[30].dark,
            contrastText: colors.primary.black,
        }
    },
    success: {
        main: colors.success[30],
        contrastText: colors.primary.white,
        buttonState: {
            hovered: colors.success[40],
            pressed: colors.success[50],
            focused: colors.success[30],
            disabled: colors.neutral[40],
            disabledText: colors.neutral[60],
        },
        darkMode : {
            main: colors.success[40],
            contrastText: colors.primary.black,
        }
    },
    warning: {
        main: colors.warning[40],
        contrastText: colors.primary.white,
    }, 
    error: {
        main: colors.red[40],
        contrastText: colors.primary.white,
        darkMode: {
            main: colors.red[20],
            contrastText: colors.primary.black,
        }
    },
    info: {
        main: colors.info[40],
        contrastText : colors.primary.white,
    }
};

export default palette;
